/////////////////////////////////////////////////////////////////////////////////////////////

var video_mode = 7; // 800x600 pixels
var video_depth = 32; // 32 bit mode
//var video_screen = 1; // start in full screen mode
var d3d_lightres = on;

/////////////////////////////////////////////////////////////////////////////////////////////

BMAP light_tga = "light.tga";

/////////////////////////////////////////////////////////////////////////////////////////////

STRING work39_wmb = "work39.wmb";

/////////////////////////////////////////////////////////////////////////////////////////////

function main()
{
	level_load (work39_wmb);
}

action players_code // simple player and 1st person camera code
{ 
	player = my; // I'm the player
	my.invisible = on; // no need to see player's model in 1st person mode
	while (1)
	{
		// move the player using the "W", "S", "A" and "D" keys; "10" = movement speed, "6" = strafing speed
		c_move (my, vector(10 * (key_w - key_s) * time_step, 6 * (key_a - key_d) * time_step, 0), nullvector, glide);
		vec_set (camera.x, player.x); // use player's x and y for the camera as well
		camera.z += 30; // place the camera 30 quants above the player on the z axis (approximate eye level)
		camera.pan -= 5 * mouse_force.x * time_step; // rotate the camera around by moving the mouse
		camera.tilt += 3 * mouse_force.y * time_step; // on its x and y axis
		player.pan = camera.pan; // the camera and the player have the same pan angle
		wait (1);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////

function fade_particle()
{
	my.alpha -= 1.2 * time_step;
	if (my.alpha < 0) {my.lifespan = 0;}
}

function effect_explo()
{
	var particle_direction;
	particle_direction.x = random(2) - 1;
	particle_direction.y = random(2) - 1;
	particle_direction.z = -random(2);
	vec_normalize (particle_direction, random(5));
	vec_add(my.vel_x, particle_direction);
	my.alpha = 30 + random(65);
	my.flare = on;
	vec_set(my.blue, vector(200, 100, 130));
	my.bmap = light_tga;
	my.size = 2; // this new line controls the size of the particle
	my.bright = on;
	my.move = on;
	my.function = fade_particle;
}

action damaged_lightbulb
{
	my.blue = 160;
	my.green = 100;
	my.red = 130;
	while (1)
	{
		my.lightrange = 500; // make the light bulb entity generate light on a radius of 500 quants
		effect(effect_explo, 1000, my.x, normal);
		sleep (0.1); // the dynamic light effect lasts for 0.1 seconds
		my.lightrange = 0; // extinguish the light bulb
		sleep (random(6) + 0.3);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////

var max_particles = 50000;

BMAP barrier_tga = "barrier.tga";

function fade_barrier()
{
	if (my.y < -400) {my.lifespan = 0;}
}

function effect_barrier()
{
	var particle_direction;
	particle_direction.x = 0;
	particle_direction.y = -50 - random(100);
	particle_direction.z = 0;
	vec_normalize (particle_direction, random(250));
	vec_add(my.vel_x, particle_direction);
	my.alpha = 30 + random(65);
	my.flare = on;
	my.bmap = barrier_tga;
	my.size = 2;
	//my.beam = on;
	//my.streak = on;
	my.bright = on;
	my.move = on;
	my.function = fade_barrier;
}

function particle_barrier_startup()
{
	while (!key_b) {wait (1);} // wait until the player presses the "B" key
	while (1)
	{
		effect(effect_barrier, 10 / (0.1 + time_step), vector(900, 450, 50 + random(100)), nullvector);
		wait (1);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////

var particle_gravity = 0;
var particle_lifespan = 0;

BMAP earth_tga = "earth.tga";

function earth_fade()
{
	my.lifespan = particle_lifespan;
	my.alpha -= 10 * time_step;
	if (my.alpha < 0) {my.lifespan = 0;}
}

function particle_earth()
{
	my.alpha = 10 + random(20);
	my.flare = on;
	my.bmap = earth_tga;
	my.size = 2;
	my.bright = on;
	my.gravity = particle_gravity;
	my.move = on;
	my.function = earth_fade; 
}

action particle_sphere
{
	my.invisible = on;
	my.passable = on;
	var particle_pos;
	while (!key_e) {wait (1);} // wait until the player presses the "E" key
	my.skill99 = 0;
	while (1)
	{
		my.skill99 += time_step / 16;
		my.skill1 = 0;
		while (my.skill1 < ent_vertices (my)) // go through all the vertices
    		{
      		my.skill1 += 1;
			vec_for_vertex(particle_pos, my, my.skill1);
			effect(particle_earth, 1, particle_pos, nullvector);
		}
		if (my.skill99 > 3) // the sphere didn't move for 3 seconds?
		{
			my.roll += 3 * time_step;
		}
		if (my.skill99 > 7) // 7 seconds have passed?
		{
			my.pan += 2 * time_step;
		}
		if (my.skill99 > 10) // 10 seconds have passed?
		{
			my.tilt += 2 * time_step;
		}
		if (my.skill99 > 15) // 15 seconds have passed?
		{
			particle_lifespan = 10;
			particle_gravity = -0.5;
		}
		if (my.skill99 > 20)
		{
			my.scale_z = 1 + 0.5 * sin(total_ticks);
		}
		wait (1);
	}
}
